/*
    anim1.c

    - Erster Versuch mit Animation: Rotation.
    - Leertaste startet und stoppt Animation.
    - Aus polygon1.c: ndern der Eckenzahl mit <-Taste und >-Taste
    - Programmabbruch mit q-Taste - siehe keyboard_func().


    > Das Programm basiert auf polygon1.c

    > glutSwapBuffers() funktioniert nur, wenn
      GLUT_DOUBLE in glutInitDisplayMode(...) angegben wurde.
      Fr Bastler: Was passiert, wenn man eines von beiden weglsst?

    > Andere Funktionen fr affine Transformationen sind
      neben glRotatef(...) noch: glTranslatef(...) und glScalef().
      Kann man damit ebenfalls kleine Animatione "bauen"? Klar...
*/




# include       <stdio.h>
# include       <stdlib.h>
# include       <math.h>
# include       <GL/gl.h>
# include       <GL/glut.h>



static int      n_vertices = 3,
                animation_laeuft = 0;
static float    theta = 0;  /* der aktuelle Rotationswinkel */



static void     display_func (void)
/*********************************/
{
    int         i;
    float       phi,
                r = 0.7,
                x, y;

    /* printf ("display_func() mit %d Vertizes\n", n_vertices); */

    glClearColor (1, 1, 1, 0);
    glClear (GL_COLOR_BUFFER_BIT);

    glLoadIdentity ();
    glRotatef (theta, 0, 0, 1);

    glColor3f (0, 0, 0);

    glBegin (GL_POLYGON);
    for (i = 0; i < n_vertices; i ++)
    {
        phi = 2 * M_PI * i / (float) n_vertices;
        x = r * cos (phi);
        y = r * sin (phi);
        glVertex2f (x, y);
    }
    glEnd ();

    glutSwapBuffers ();
    /* glFlush (); nicht mehr ntig, wenn glutSwapBuffers() benutzt wird. */
    glutReportErrors ();
}



static void     idle_func (void)
/******************************/
{
    theta += 0.1;
    glutPostRedisplay ();
}



static void     keyboard_func (unsigned char key, int x, int y)
/*************************************************************/
{
    switch (key)
    {
        case ' ':   /* Leertaste */
            if (animation_laeuft)
            {
                animation_laeuft = 0;
                glutIdleFunc (0);
            }
            else
            {
                animation_laeuft = 1;
                glutIdleFunc (idle_func);
            }
            break;

        case ',':
        case '<':
            if (n_vertices > 3)
                n_vertices --;
            glutPostRedisplay ();
            break;

        case '.':
        case '>':
            n_vertices ++;
            glutPostRedisplay ();
            break;

        case 'q':
        case 'Q':
            exit (0);
    }
}



extern int      main (int argc, char **argv)
/******************************************/
{
    glutInit (&argc, argv);
    glutInitDisplayMode (GLUT_RGB | GLUT_DOUBLE);

    glutInitWindowPosition (200, 100);
    glutInitWindowSize (600, 600);
    glutCreateWindow ("anim1");

    glutDisplayFunc (display_func);
    glutKeyboardFunc (keyboard_func);

    glutMainLoop ();

    return 0;
}


